<template>
    <Base activeIndex="2">
    </Base>
    <div class="container">
        <el-row class="header">
            <el-col>
                修改德育分活动
            </el-col>
        </el-row>
        <el-row>
            <el-card class="box-card">
                <div class="main">
                    <el-col :span="6" :offset="1">
                        <img src="../assets/library2.jpg" alt="">
                    </el-col>
                    <el-col :offset="7" class="form">
                        <el-form ref="ruleFormRef" :model="ruleForm" :rules="rules" label-width="80px"
                            class="demo-ruleForm" :size="formSize">
                            <el-form-item label="活动编号" prop="aid">
                                <el-input v-model="ruleForm.aid" />
                            </el-form-item>
                            <el-form-item label="活动名称" prop="topic">
                                <el-input v-model="ruleForm.topic" />
                            </el-form-item>

                            <el-form-item label="起始时间" required>
                                <el-col :span="11">
                                    <el-form-item prop="date1">
                                        <el-date-picker v-model="ruleForm.date1" type="date" label="Pick a date"
                                            placeholder="Pick a date" style="width: 100%" />
                                    </el-form-item>
                                </el-col>
                                <el-col class="text-center" :span="2">
                                    <span class="text-gray-500">-</span>
                                </el-col>
                                <el-col :span="11">
                                    <el-form-item prop="time1">
                                        <el-time-picker v-model="ruleForm.time1" label="Pick a time"
                                            placeholder="Pick a time" style="width: 100%" />
                                    </el-form-item>
                                </el-col>
                            </el-form-item>
                            <el-form-item label="结束时间" required>
                                <el-col :span="11">
                                    <el-form-item prop="date2">
                                        <el-date-picker v-model="ruleForm.date2" type="date" label="Pick a date"
                                            placeholder="Pick a date" style="width: 100%" />
                                    </el-form-item>
                                </el-col>
                                <el-col class="text-center" :span="2">
                                    <span class="text-gray-500">-</span>
                                </el-col>
                                <el-col :span="11">
                                    <el-form-item prop="time2">
                                        <el-time-picker v-model="ruleForm.time2" label="Pick a time"
                                            placeholder="Pick a time" style="width: 100%" />
                                    </el-form-item>
                                </el-col>
                            </el-form-item>
                            <el-form-item label="负责学院" prop="region">
                                <el-input v-model="ruleForm.academy">
                                </el-input>
                            </el-form-item>
                            <el-form-item label="活动分数" prop="name">
                                <el-input v-model="ruleForm.score" />
                            </el-form-item>
                            <el-form-item label="活动人数" prop="nums">
                                <el-input v-model="ruleForm.nums" />
                            </el-form-item>
                            <el-form-item label="活动描述" prop="desc">
                                <el-input v-model="ruleForm.desc" type="textarea" />
                            </el-form-item>
                            <el-form-item>
                                <el-button type="primary" @click="submitForm(ruleFormRef)" class="submitBtn">
                                确认提交
                                </el-button>
                            </el-form-item>
                        </el-form>
                    </el-col>
                </div>
            </el-card>
        </el-row>
    </div>
</template>

<script lang="ts">
import axios from "axios";
import Base from "./Base.vue";

export default {
    name: "ActivityModify",
    data() {
        return {

        }
    },
    components: {
        Base
    },

}
</script>

<script lang="ts" setup>
import { reactive, ref } from 'vue'
import global from "./Common.vue"
import type { FormInstance, FormRules } from 'element-plus'

function getQueryVariable(variable) {
    var query = window.location.search.substring(1);
    var vars = query.split("&");
    for (var i = 0; i < vars.length; i++) {
        var pair = vars[i].split("=");
        if (pair[0] == variable) { return decodeURI(pair[1]); }
    }
    return (false);
};
const formSize = ref('default')
const ruleFormRef = ref<FormInstance>()
const ruleForm = reactive({
    aid: getQueryVariable("id"),
    topic: '',
    score: '',
    date1: '',
    time1: "",
    date2: '',
    time2: "",
    academy: '',
    nums: '',
    desc: '',
})

let token = localStorage.getItem('token');
axios({
    method: "POST",
    url: "http://" + global.ip + "/api/browse/details/" + ruleForm.aid,
    headers: { Authorization: `Bearer: ${token}` }
}).then((res) => {
    console.log(res);
    if (res.data.code == '00') {
        ruleForm.aid = res.data.activity.id;
        ruleForm.topic = res.data.activity.topic;
        ruleForm.score = res.data.activity.score;
        ruleForm.date1 = res.data.activity.startTime;
        ruleForm.time1 = res.data.activity.startTime;
        ruleForm.date2 = res.data.activity.endTime;
        ruleForm.time2 = res.data.activity.endTime;
        ruleForm.academy = res.data.activity.academy;
        ruleForm.nums = res.data.activity.maximum;
        ruleForm.desc = res.data.activity.content;
    }

})

const rules = reactive<FormRules>({
    topic: [
        { required: true, message: '请输入活动名称', trigger: 'blur' },
    ],
    nums: [{
        required: true
    }],
    academy: [
        {
            required: true,
            message: '必须选择负责学院',
            trigger: 'change',
        },
    ],
    date1: [
        {
            type: 'date',
            required: true,
            message: '选择活动起始时间',
            trigger: 'change',
        },
    ],
    date2: [
        {
            type: 'date',
            required: true,
            message: '选择活动结束时间',
            trigger: 'change',
        },
    ],
    desc: [
        { required: true, message: '请输入活动详情', trigger: 'blur' },
    ],
})

const submitForm = async (formEl: FormInstance | undefined) => {
    if (!formEl) return
    await formEl.validate((valid, fields) => {
        if (valid) {
            let datestr1 = String(ruleForm.date1)
            let datestr2 = String(ruleForm.date2)
            let datestrs1 = datestr1.split(" ")
            let datestrs2 = datestr2.split(" ")
            let date1str = datestrs1[3]+'-06-'+datestrs1[2] + ' '
            let date2str = datestrs2[3]+'-06-'+datestrs2[2] + ' '

            let timestr1 = String(ruleForm.time1)
            let timestr2 = String(ruleForm.time2)
            let timestrs1 = timestr1.split(" ")
            let timestrs2 = timestr2.split(" ")
            let time1str = timestrs1[4]
            let time2str = timestrs2[4]

            axios({
                method: "POST",
                url: "http://" + global.ip + "/api/manage/changeAct",
                data: {
                    aid: ruleForm.aid,
                    topic: ruleForm.topic,
                    content: ruleForm.desc,
                    stime: date1str+time1str,
                    etime: date2str+time2str,
                    cid: ruleForm.academy,
                    score: ruleForm.score,
                },
                headers: { Authorization: `Bearer: ${token}` }
            }).then((res) => {
                console.log(res);
                if (res.data.code != '00')
                    alert(res.data.msg);
                window.location.replace("http://" + global.ip_front + "/activities_detailed");
            });
        } else {
            console.log('error submit!', fields)
        }
    })
}

</script>

<style scoped>
a {
    text-decoration: none;
    color: white;
}

.container {
    position: absolute;
    width: 100%;
    height: 100%;
    background-color: rgb(238, 241, 246);
}

.box-card {
    position: relative;
    width: 75%;
    height: 80%;
    top: 70px;
    left: 200px;
    padding: 50px;
}

img {
    width: 700px;
    height: 600px;
}

.form {
    position: relative;
    top: 50px;
}

.header {
    position: relative;
    font-size: 50px;
    top: 30px;
}

/deep/ .el-form-item {
    margin-bottom: 30px;
}

/deep/ .submitBtn {
    position: relative;
    width: 130px;
    height: 50px;
    font-size: 20px;
    left: 120px;
}
</style>